import 'package:flutter_mylibrary/utils/utils.dart';

import 'base_view_state.dart';

mixin BaseRequestListController<T> implements BaseViewState{

  /// 页面数据
  List<T> list = [];

  onCompleted(List<T> data) {}



  ///获取数据
  void getData(){
    request((data){
      if (isNotEmpty(data)) {
        list = data is List? List<T>.from(data.map((e) => getRequestInfo()?.handleRes(e))).toList() : getRequestInfo()?.handleRes(data);
        onCompleted(list);
      }else{
        setEmptyDataError(data);
      }
    });
  }


  void requestWhenError(){
    setBusy();
    getData();
  }
}